/* Author:  B. Gough and G. Jungman
 * RCS:     $Id: gsl_precision.h,v 1.3 1998/12/15 17:46:24 jungman Exp $
 */
#ifndef GSL_PRECISION_H
#define GSL_PRECISION_H


/* A type for the precision indicator.
 * This is mainly for pedagogy.
 */
typedef  unsigned int  gsl_prec_t;


/* The number of precision types.
 * Remember that precision-mode
 * can index an array.
 */
#define _GSL_PREC_T_NUM 3


/* Arrays containing derived
 * precision constants for the
 * different precision levels.
 */
extern const double gsl_prec_eps[];
extern const double gsl_sqrt_prec_eps[];
extern const double gsl_root3_prec_eps[];
extern const double gsl_root4_prec_eps[];
extern const double gsl_root5_prec_eps[];
extern const double gsl_root6_prec_eps[];


#endif /* !GSL_PRECISION_H */
